import * as assert from 'assert';
import Asynctor from '../src';

class Demo extends Asynctor {
  private _word!: string;

  constructor() {
    super(async () => {
      await new Promise(resolve => setTimeout(resolve, 1000));
      this._word = 'world!';
    });
  }

  public async sayHello() {
    console.log(`Hello ${this._word}`);
    assert(this._word === 'world!');
  }
}

describe('Asynctor', () => {
  it('it should ok', async () => {
    const demo = new Demo();
    await demo.sayHello();
  });
});
